'--------------------------------------------------------------
' Clipboard Magnet - Michael S. Sanders
'--------------------------------------------------------------
$FILETEST OFF
GUI "Clipboard Magnet", PIXELS, ICON, 2

'--------------------------------------------------------------
' Constants
'--------------------------------------------------------------

CONST idOFF =  3
CONST idON  =  4
CONST idWAV =  5
CONST idMON =  6
CONST idQUE =  7
CONST idVUE =  8
CONST idWPE =  9
CONST idHLP = 10
CONST idABT = 11
CONST idCPY = 12
CONST idALL = 13
CONST idEXT = 14

'--------------------------------------------------------------
' Includes
'--------------------------------------------------------------

' local
$INCLUDE "inc\events.bcx"
$INCLUDE "inc\history.bcx"
$INCLUDE "inc\misc.bcx"
$INCLUDE "inc\tray.bcx"

'--------------------------------------------------------------
' Top Level Declarations
'--------------------------------------------------------------
Raw hFRM As HANDLE
Raw hNXT As HANDLE
Raw hLOG As HANDLE
Raw hVUE As HANDLE

Raw pt   As POINT
Raw d    As DWORD
Raw rc   As RECT
Raw hDFR As HDWP
Raw ftx  As FINDTEXTEX
Raw hMNU AS HMENU

Raw DRV$ ' current drive
Raw CBH$ ' full path to pasteboard file
Raw Fnt$ ' font for history view port

' l - length of clipboard txt
' m - monitor 0|1
' w - working 0|1
' q = 0|1 --> ToggleQue()
' v - view 1|0

Raw q,l,m,w,v

'--------------------------------------------------------------
' Tray Icon
'--------------------------------------------------------------
CONST WM_SHELLNOTIFY = WM_USER + 5 ' shell notify message
Raw nid        As NOTIFYICONDATA   ' tray icon structure
Raw mTRAY      As HMENU            ' tray menu
Raw TB_CREATED As LONG             ' taskbar created message
Raw hICO2      As HICON            ' off icon
Raw hICO1      As HICON            ' on icon

'--------------------------------------------------------------
Sub Formload()
'--------------------------------------------------------------
DRV$ = CHR$(GETDRIVE() + 64) & ":\"
CBH$ = APPEXEPATH$ & "History.txt"
Fnt$ = iif$(Exist(GETSPECIALFOLDER$(CSIDL_FONTS) & "\Dina.fon"), "Dina", "Courier New")

InitCommonControls()

w = 0 : m = 0 : v = 0

If ! EXIST(CBH$) Then AppendLog(CBH$,"File created on: " & DATE$)

hFRM  = BCX_FORM(0) : FlushClipboard()
hICO2 = LoadImage(BCX_HINSTANCE,MAKEINTRESOURCE(idOFF),IMAGE_ICON,16,16,LR_DEFAULTCOLOR)
hICO1 = LoadImage(BCX_HINSTANCE,MAKEINTRESOURCE(idON),IMAGE_ICON,16,16,LR_DEFAULTCOLOR)

hMNU = CreatePopupMenu()
AppendMenu(hMNU,MF_STRING,idCPY,"Copy")
AppendMenu(hMNU,MF_STRING,idALL,"Select All")
AppendMenu(hMNU,MF_SEPARATOR,0,0)
AppendMenu(hMNU,MF_STRING,idHLP,"Help")
AppendMenu(hMNU,MF_SEPARATOR,0,0)
AppendMenu(hMNU,MF_STRING,idEXT,"Close")

TraySetup()
Center(hFRM)

ToggleMon()
q = ToggleQue()

End Sub
